All of lore.kernel.org
 help / color / mirror / Atom feed
From: Eryu Guan <eguan@redhat.com>
To: fstests@vger.kernel.org
Cc: Eryu Guan <eguan@redhat.com>
Subject: [PATCH v2 5/9] generic: test fs freeze/unfreeze and mount/umount race
Date: Wed,  1 Apr 2015 21:53:25 +0800	[thread overview]
Message-ID: <1427896405-11908-1-git-send-email-eguan@redhat.com> (raw)
In-Reply-To: <1426846618-23413-6-git-send-email-eguan@redhat.com>

Exercise fs freeze/unfreeze and mount/umount race, which could lead to
use-after-free oops.

This commit fixed the issue:
1494583 fix get_active_super()/umount() race

This test case is based on a script from Monakhov Dmitriy.

Signed-off-by: Eryu Guan <eguan@redhat.com>
---
v2:
- add comments to explain dmsetup is used not xfs_freeze to freeze filesystem
- detect failures in setup phase, so test exits not continus with errors

 tests/generic/080     | 102 ++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/generic/080.out |   2 +
 tests/generic/group   |   1 +
 3 files changed, 105 insertions(+)
 create mode 100755 tests/generic/080
 create mode 100644 tests/generic/080.out

diff --git a/tests/generic/080 b/tests/generic/080
new file mode 100755
index 0000000..fd460b1
--- /dev/null
+++ b/tests/generic/080
@@ -0,0 +1,102 @@
+#! /bin/bash
+# FS QA Test No. 080
+#
+# Exercise fs freeze/unfreeze and mount/umount race, which could lead to
+# use-after-free oops.
+#
+# This commit fixed the issue:
+# 1494583 fix get_active_super()/umount() race
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2015 Red Hat Inc. All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+	cleanup_dmdev
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+_require_scratch
+_require_block_device $SCRATCH_DEV
+_require_command $DMSETUP_PROG
+_require_freeze
+
+setup_dmdev()
+{
+	table="0 $size_in_sector linear $SCRATCH_DEV 0"
+	$DMSETUP_PROG create $node --table "$table" >>$seqres.full 2>&1 && \
+	$DMSETUP_PROG mknodes >/dev/null 2>&1
+	return $?
+}
+
+cleanup_dmdev()
+{
+	# in case it's still suspended and/or mounted
+	$DMSETUP_PROG resume $lvdev >/dev/null 2>&1
+	$UMOUNT_PROG $lvdev >/dev/null 2>&1
+
+	$DMSETUP_PROG remove $node >>$seqres.full 2>&1
+	$DMSETUP_PROG mknodes >/dev/null 2>&1
+}
+
+rm -f $seqres.full
+echo "Silence is golden"
+
+size=$((256 * 1024 * 1024))
+size_in_sector=$((size / 512))
+_scratch_mkfs_sized $size >>$seqres.full 2>&1
+
+node=$seq-test
+lvdev=/dev/mapper/$node
+setup_dmdev || _fail "setup dm device failed"
+
+# take use of dmsetup suspend to freeze the fs.
+# xfs_freeze/fsfreeze cannot be used in this test, because it can possibly
+# freeze the root fs of the host when SCRATCH_MNT is not mounted
+for ((i=0; i<100; i++)); do
+	$DMSETUP_PROG suspend $lvdev >/dev/null 2>&1
+	$DMSETUP_PROG resume $lvdev >/dev/null 2>&1
+done &
+pid=$!
+for ((i=0; i<100; i++)); do
+	$MOUNT_PROG $lvdev $SCRATCH_MNT >/dev/null 2>&1
+	$UMOUNT_PROG $lvdev >/dev/null 2>&1
+done &
+pid="$pid $!"
+
+wait $pid
+
+status=0
+exit
diff --git a/tests/generic/080.out b/tests/generic/080.out
new file mode 100644
index 0000000..11a4a1a
--- /dev/null
+++ b/tests/generic/080.out
@@ -0,0 +1,2 @@
+QA output created by 080
+Silence is golden
diff --git a/tests/generic/group b/tests/generic/group
index ee5b642..cf7408c 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -82,6 +82,7 @@
 077 acl attr auto enospc
 078 auto quick metadata
 079 acl attr ioctl metadata auto quick
+080 auto freeze mount
 083 rw auto enospc stress
 088 perms auto quick
 089 metadata auto
-- 
2.1.0


  parent reply	other threads:[~2015-04-01 13:53 UTC|newest]

Thread overview: 41+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2015-03-20 10:16 [PATCH 0/9] some backlog patches and new test and fixes Eryu Guan
2015-03-20 10:16 ` [PATCH 1/9 RESEND] generic: test some mount/umount corner cases Eryu Guan
2015-03-25 19:32   ` Brian Foster
2015-03-20 10:16 ` [PATCH 2/9 RESEND] generic: test quota handling on remount ro failure Eryu Guan
2015-03-25 19:32   ` Brian Foster
2015-04-01  6:06     ` Eryu Guan
2015-04-01 14:13       ` Brian Foster
2015-03-20 10:16 ` [PATCH 3/9 RESEND] generic: test hardlink to unlinked file Eryu Guan
2015-03-25 19:32   ` Brian Foster
2015-03-27 10:10     ` Eryu Guan
2015-04-01 13:48   ` [PATCH v2 3/9] " Eryu Guan
2015-04-01 17:54     ` Brian Foster
2015-04-02  2:59       ` Eryu Guan
2015-04-02 11:17         ` Brian Foster
2015-03-20 10:16 ` [PATCH 4/9 RESEND] shared: test truncate orphan inodes when mounting extN Eryu Guan
2015-03-20 10:16 ` [PATCH 5/9 RESEND] generic: test fs freeze/unfreeze and mount/umount race Eryu Guan
2015-03-25 19:44   ` Brian Foster
2015-03-27  8:46     ` Eryu Guan
2015-03-27 12:10       ` Brian Foster
2015-03-27 13:38         ` Eryu Guan
2015-04-01 13:53   ` Eryu Guan [this message]
2015-04-01 17:56     ` [PATCH v2 5/9] " Brian Foster
2015-04-02 12:15       ` Eryu Guan
2015-03-20 10:16 ` [PATCH 6/9] generic: test I/O error path by fully filling dm snapshot Eryu Guan
2015-03-25 23:08   ` Brian Foster
2015-03-27  7:38     ` Eryu Guan
2015-03-27 12:10       ` Brian Foster
2015-04-01 13:54   ` Eryu Guan
2015-04-01 17:57     ` Brian Foster
2015-04-01 22:29       ` Dave Chinner
2015-04-02  4:10         ` Eryu Guan
2015-04-02 11:11           ` Brian Foster
2015-04-07  1:36             ` Dave Chinner
2015-04-01 22:41     ` Dave Chinner
2015-04-02 12:08       ` Eryu Guan
2015-03-20 10:16 ` [PATCH 7/9] common: recognise NFS export over IPv6 in _require_scratch_nocheck() Eryu Guan
2015-03-25 23:08   ` Brian Foster
2015-03-20 10:16 ` [PATCH 8/9] xfs/014: replace df with $DF_PROG Eryu Guan
2015-03-25 23:08   ` Brian Foster
2015-03-20 10:16 ` [PATCH 9/9] generic/077: add missing _require_scratch Eryu Guan
2015-03-25 23:08   ` Brian Foster

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1427896405-11908-1-git-send-email-eguan@redhat.com \
    --to=eguan@redhat.com \
    --cc=fstests@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.